
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -0.0001
#property indicator_maximum 0.0001
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Blue
#property indicator_color3 Red

extern int period = 32;
double G_ibuf_80[];
double G_ibuf_84[];
double G_ibuf_88[];
string Gs_92 = "";
string Gs_100 = "SEFC-Bull-Bear";

int init() {
   SetIndexStyle(0, DRAW_HISTOGRAM, STYLE_SOLID, 4);
   SetIndexStyle(1, DRAW_HISTOGRAM, STYLE_SOLID, 4);
   SetIndexStyle(2, DRAW_HISTOGRAM, STYLE_SOLID, 4);
   IndicatorDigits(Digits + 1);
   SetIndexBuffer(0, G_ibuf_80);
   SetIndexBuffer(1, G_ibuf_84);
   SetIndexBuffer(2, G_ibuf_88);
   IndicatorShortName(Gs_100);
   SetIndexLabel(1, NULL);
   SetIndexLabel(2, NULL);
   StempelSEFC();
   return (0);
}

int start() {
   double Ld_0;
   double Ld_8;
   double Ld_16;
   int Li_28 = IndicatorCounted();
   if (Li_28 < 0) return (-1);
   if (Li_28 > 0) Li_28--;
   int Li_24 = Bars - Li_28;
   double Ld_unused_32 = GetTickCount();
   if (Li_24 > 2500) Li_24 = 2500;
   double Ld_unused_40 = GetTickCount();
   Print("Calculation time is ", 0.9, " seconds");
   double Ld_48 = 0;
   double Ld_56 = 0;
   double Ld_unused_64 = 0;
   double Ld_unused_72 = 0;
   double Ld_80 = 0;
   double Ld_unused_88 = 0;
   double low_96 = 0;
   double high_104 = 0;
   creataalltext();
   int Li_112 = 16777215;
   if (Li_28 > 0) Li_28--;
   int Li_116 = Bars - Li_28;
   for (int Li_120 = 0; Li_120 < Li_116; Li_120++) {
      high_104 = High[iHighest(NULL, 0, MODE_HIGH, period, Li_120)];
      low_96 = Low[iLowest(NULL, 0, MODE_LOW, period, Li_120)];
      Ld_16 = (High[Li_120] + Low[Li_120]) / 2.0;
      Ld_48 = 0.66 * ((Ld_16 - low_96) / (high_104 - low_96) - 0.5) + 0.67 * Ld_56;
      Ld_48 = MathMin(MathMax(Ld_48, -0.999), 0.999);
      G_ibuf_80[Li_120] = MathLog((Ld_48 + 1.0) / (1 - Ld_48)) / 2.0 + Ld_80 / 2.0;
      Ld_56 = Ld_48;
      Ld_80 = G_ibuf_80[Li_120];
   }
   bool Li_124 = TRUE;
   for (Li_120 = Li_116 - 2; Li_120 >= 0; Li_120--) {
      Ld_8 = G_ibuf_80[Li_120];
      Ld_0 = G_ibuf_80[Li_120 + 1];
      if ((Ld_8 < 0.0 && Ld_0 > 0.0) || Ld_8 < 0.0) Li_124 = FALSE;
      if ((Ld_8 > 0.0 && Ld_0 < 0.0) || Ld_8 > 0.0) Li_124 = TRUE;
      if (!Li_124) {
         G_ibuf_88[Li_120] = Ld_8;
         G_ibuf_84[Li_120] = 0.0;
         Gs_92 = "Saat ini volatile = Bear";
         Li_112 = 65535;
      } else {
         G_ibuf_84[Li_120] = Ld_8;
         G_ibuf_88[Li_120] = 0.0;
         Gs_92 = "Saat ini volatile = Bull";
         Li_112 = 65280;
      }
   }
   settext("SEFC X4bd Repro", Gs_92, 14, Li_112, 10, 15);
   return (0);
}

void creataalltext() {
   createtext("SEFC x4bd Repro");
   settext("SEFC x4bd Repro", "", 14, White, 10, 15);
}

void createtext(string A_name_0) {
   ObjectCreate(A_name_0, OBJ_LABEL, WindowFind(Gs_100), 0, 0);
}

void settext(string A_name_0, string A_text_8, int A_fontsize_16, color A_color_20, int A_x_24, int A_y_28) {
   ObjectSet(A_name_0, OBJPROP_XDISTANCE, A_x_24);
   ObjectSet(A_name_0, OBJPROP_YDISTANCE, A_y_28);
   ObjectSetText(A_name_0, A_text_8, A_fontsize_16, "Arial", A_color_20);
}

void StempelSEFC() {
   ObjectCreate("Original Created by SEFC", OBJ_LABEL, 0, 0, 0);
   ObjectSetText("Original Created by SEFC", "SEFC *PALATO* - (Palato = Under earth Kingdom)", 8, "Lucida Handwriting", SpringGreen);
   ObjectSet("Original Created by SEFC", OBJPROP_CORNER, 2);
   ObjectSet("Original Created by SEFC", OBJPROP_XDISTANCE, 5);
   ObjectSet("Original Created by SEFC", OBJPROP_YDISTANCE, 10);
}
